package com.njcn.energy.pojo.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.energy.pojo.api.EleAirStrategyFeignClient;
import com.njcn.energy.pojo.utils.EnergyEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;


/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/4/20 15:09
 */
@Slf4j
@Component
public class EleAirStrategyFallbackFactory implements FallbackFactory<EleAirStrategyFeignClient>  {


    @Override
    public EleAirStrategyFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if(cause.getCause() instanceof BusinessException){
            BusinessException businessException = (BusinessException) cause.getCause();
            exceptionEnum = EnergyEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new EleAirStrategyFeignClient() {
            @Override
            public void dealAirStrategyId(String operation) {
                log.error("{}异常，降级处理，异常为：{}","空调控制策略数据",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
